﻿Imports Infragistics.Olap.FlatData

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
        SetupTestData()
    End Sub

    Private Sub SetupTestData()

        Dim td As New List(Of TestData)
        For j = 1 To 10
            For i = 1 To 10
                td.Add(New TestData("L1_" & j.ToString, "R" & i.ToString, "C0", Rnd() * 1000))
            Next
        Next

        Dim flatDS = New FlatDataSource With {
            .ItemsSource = td,
            .Cube = FlatDataSource.GenerateInitialCube("FlatData"),
            .Rows = FlatDataSource.GenerateInitialItems("[Header1].[Header1]"),
            .Columns = FlatDataSource.GenerateInitialItems("[Header2].[Header2]"),
            .Measures = FlatDataSource.GenerateInitialItems("Value")
        }

        Dim hierH1 As New HierarchyDescriptor With {.AppliesToPropertiesOfType = GetType(Header), .HierarchyName = "Header1"}
        hierH1.AddLevel(Of Header)(Function(h) h.Level1, "Level1")
        hierH1.AddLevel(Of Header)(Function(h) h.Level2, "Level2")
        flatDS.AddHierarchyDescriptor(hierH1)

        myGrid.DataSource = flatDS
        myDS.DataSource = flatDS

    End Sub

    Private Sub chkTotals_Checked(sender As Object, e As System.Windows.RoutedEventArgs) Handles chkTotals.Checked
        HideTotalsInGrid()
    End Sub

    Private Sub myGrid_LayoutLoaded(sender As Object, e As System.EventArgs) Handles myGrid.LayoutLoaded
        HideTotalsInGrid()
    End Sub

    Private Sub myGrid_LayoutUpdated(sender As Object, e As System.EventArgs) Handles myGrid.LayoutUpdated
        HideTotalsInGrid()
    End Sub

    Private Sub HideTotalsInGrid()
        Dim show As Boolean = Not chkTotals.IsChecked
        For Each r In myGrid.DataRows
            If r.IsTotal And (r.IsVisible Xor show) Then r.IsVisible = show
        Next
    End Sub

End Class

Public Class TestData
    Public Sub New(h1a As String, h1b As String, h2 As String, v As Double)
        Header1.Level1 = h1a
        Header1.Level2 = h1b
        Header2 = h2
        Value = v
    End Sub
    Public Property Header1 As New Header
    Public Property Header2 As String
    Public Property Value As Double
End Class

Public Class Header
    Public Property Level1 As String
    Public Property Level2 As String
End Class
